//+------------------------------------------------------------------+
//|                  Buscador(3) - SuperTrend volty like 2 - nmt.mq4 |
//|                                      TradingUnited - Grupo Renko |
//|                                       http://www.tradingunited.es|
//+------------------------------------------------------------------+
#property copyright "TradingUnited - Grupo Renko"
#property link      "http://www.tradingunited.es"
#property version   "1.00"
#property strict
//+------------------------------------------------------------------+
#include <stdlib.mqh>
#include <stderror.mqh>
//+------------------------------------------------------------------+

input string     ExpertName                    = "=== Buscador(3) - SuperTrend volty like 2 - nmt ===";

input string     GeneralParameters             = "===== GENERAL PARAMETERS =====";

input int        Magic                         = 456789;      
input bool       SpreadProtection              = true;        
input int        MaxSpreadPermitted            = 2;           
input int        MaxSlippage                   = 2;           
input int        MaximumVolumeSize             = 10;          
input string     CustomComment                 = "Setting 1"; 

input string     OrderSettings                 = "===== ORDER SETTINGS =====";

input bool       StarNewSignal                 = true;

input string     MoneyManagement               = "===== MONEY MANAGEMENT =====";

input double     LotSize                       = 0.01;        

input string     CustomMartingale              = "===== CUSTOM MARTINGALE =====";

input bool       UseMartingaleLoss             = false;
input bool       UseMartingaleBreakEven        = false;

input double     MultiplyOnLoss                = 2.5;         
input double     MultiplyOnBreakEven           = 2.5;         

input string     Control_StopLoss_BreakEven    = "===== CONTROL STOP LOSS - BREAKEVEN =====";

input bool       UseStopLoss                   = false;
input double     StopLossPips                  = 40;

input bool       UseBreakEven                  = false;
input double     BreakEvenAtPips               = 20;          
input double     BreakEvenSlidePips            = 10;           

input string     IndicatorsSettings            = "===== INDICATORS SETTINGS=====";

input string     _1                            = "===== SuperTrend volty like 2 - nmt =====";
extern string    TimeFrame                     = "Current time frame";
extern int       period                        = 10;
extern int       appliedPrice                  = PRICE_CLOSE;
extern double    multiplier                    = 4.0;
extern string    note                          = "turn on Alert = true; turn off = false";
extern bool      alertsOn                      = false;
extern bool      alertsOnCurrent               = false;
extern bool      alertsMessage                 = false;
extern bool      alertsSound                   = false;
extern bool      alertsEmail                   = false;
extern string    soundfile                     = "alert2.wav";     

bool dummyResult;
int timeFrame;

//+------------------------------------------------------------------+
//| Local Parameters Definition                                      |
//+------------------------------------------------------------------+
int DecimalPoints;
double point;
datetime lastCandle, EAStartCandle;
int signal, bar;
int Slippage;
string gbl = "Buscador(3) - SuperTrend volty like 2 - nmt";
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
{
   timeFrame = stringToTimeFrame(TimeFrame);
  //------------------------------------------------------------------
  DecimalPoints = 1;
  double x = MarketInfo(Symbol(), MODE_LOTSTEP) * 10;
  while (x < 1)
  { x *= 10; DecimalPoints += 1; }
  //------------------------------------------------------------------
  point = _Point;
  Slippage = MaxSlippage;
  if (_Digits == 3 || _Digits == 5)
  {
    point = _Point * 10;
    Slippage = MaxSlippage * 10;
  }
  //------------------------------------------------------------------
  lastCandle = Time[0]; signal = -1; bar = -1; EAStartCandle = Time[0];
  if (IsTesting()) { gbl = "B." + gbl; GlobalVariablesDeleteAll(gbl); }
  //------------------------------------------------------------------
  return(INIT_SUCCEEDED);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
{
  //------------------------------------------------------------------
  //------------------------------------------------------------------
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
void OnTick()

{
  //------------------------------------------------------------------
  if (lastCandle != Time[0])
  {
    lastCandle = Time[0];
    signal = GetSignal(bar);
  }
  //------------------------------------------------------------------
  if (signal != -1 && TimeCurrent()-Time[0] < 15)
  {
    if (signal == OP_SELL && IsAnyOrderActive(OP_BUY) != -1)
      dummyResult = OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), Slippage, Blue);
    else if (signal == OP_BUY && IsAnyOrderActive(OP_SELL) != -1)
      dummyResult = OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), Slippage, Red);
    if ((!SpreadProtection || NormalizeDouble(Ask-Bid-MaxSpreadPermitted*point, _Digits)<=0) && DoesSignalCatched(signal, Time[bar]) == -1)
      if ((!StarNewSignal || bar == 1) && IsAnyOrderActive(signal) == -1) SetOrder(signal);
  }
  //------------------------------------------------------------------
  ManageSL();
  ManageTrade();
  //------------------------------------------------------------------
 
}
//+------------------------------------------------------------------+
int SetOrder(int type)
{
  double price = 0, sl = 0;
  int cmd = -1;
  color col = clrBlack;
  if (type == OP_BUY) { cmd = OP_BUY; price = Ask; col = clrBlue; }
  if (type == OP_SELL) { cmd = OP_SELL; price = Bid; col = clrRed; }
  double lot = LotSize;
  if (UseMartingaleLoss || UseMartingaleBreakEven)
  {
    int last = GetLastClosedOrder();
    if (last != -1)
    {
      if (OrderProfit() < 0 && UseMartingaleLoss) lot = NormalizeDouble(MultiplyOnLoss * OrderLots(), DecimalPoints);
      if (OrderProfit() >= 0 && OrderStopLoss() != 0 && UseMartingaleBreakEven)
      {
        if (OrderType() == OP_BUY && NormalizeDouble(OrderClosePrice()-OrderStopLoss(), _Digits)<=0) lot = NormalizeDouble(MultiplyOnBreakEven * OrderLots(), DecimalPoints);
        if (OrderType() == OP_SELL && NormalizeDouble(OrderClosePrice()-OrderStopLoss(), _Digits)>=0) lot = NormalizeDouble(MultiplyOnBreakEven * OrderLots(), DecimalPoints);
      }
    }
  }
  if (NormalizeDouble(lot-MaximumVolumeSize, DecimalPoints)>0) lot = NormalizeDouble(MaximumVolumeSize, DecimalPoints);
  int ticket = OrderSend(Symbol(), cmd, lot, NormalizeDouble(price, _Digits), Slippage, 0, 0, CustomComment, Magic, 0, col);
  int err = GetLastError();
  if (ticket == -1 && err > 0)
    Print("err=", IntegerToString(err), ", type=" + IntegerToString(type), ", price=", DoubleToStr(price, _Digits), ", lot=", DoubleToStr(lot, DecimalPoints), ", ", ErrorDescription(err));
  else if (ticket != -1) ManageSL();
  return (ticket);
}
//+------------------------------------------------------------------+
int DoesSignalCatched(int type, datetime from)
{
  int i;
  if (from < EAStartCandle) from = EAStartCandle;
  for (i = OrdersTotal() - 1; i >= 0; i--)
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == Magic && OrderOpenTime() >= from && OrderType() == type)
        return (OrderTicket());
  for (i = OrdersHistoryTotal() - 1; i >= 0; i--)
    if (OrderSelect(i, SELECT_BY_POS, MODE_HISTORY))
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == Magic && OrderOpenTime() >= from && OrderType() == type)
        return (OrderTicket());
  return (-1);
}
//+------------------------------------------------------------------+
int IsAnyOrderActive(int type)
{
  for (int i = OrdersTotal() - 1; i >= 0; i--)
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == Magic && OrderType() == type)
        return (OrderTicket());
  return (-1);
}
//+------------------------------------------------------------------+
int GetLastClosedOrder(int exception = -1)
{
  int ticket = -1; datetime OpenTime = -1;
  for (int i = OrdersHistoryTotal() - 1; i >= 0; i--)
    if (OrderSelect(i, SELECT_BY_POS, MODE_HISTORY))
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == Magic && (OrderType() == OP_BUY || OrderType() == OP_SELL))
        if (OrderTicket() != exception && OrderOpenTime() > OpenTime)
        {
          ticket = OrderTicket(); OpenTime = OrderOpenTime();
        }
  if (ticket != -1) dummyResult = OrderSelect(ticket, SELECT_BY_TICKET);
  return (ticket);
}
//+------------------------------------------------------------------+
void ManageTrade()
{
  double sl;
  for (int i = OrdersTotal() - 1; i >= 0; i--)
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == Magic)
      {
        sl = GlobalVariableGet(gbl+IntegerToString(OrderTicket())+".SL");
        if (sl != 0 && OrderType() == OP_BUY)
        {
          if (UseBreakEven && NormalizeDouble(Bid-OrderOpenPrice()-BreakEvenAtPips*point, _Digits)>=0)
            if (NormalizeDouble(sl, _Digits)<NormalizeDouble(OrderOpenPrice()+BreakEvenSlidePips*point, _Digits))
            {
              sl = NormalizeDouble(OrderOpenPrice()+BreakEvenSlidePips*point, _Digits);
              dummyResult = OrderModify(OrderTicket(), OrderOpenPrice(), sl, OrderTakeProfit(), 0);
              GlobalVariableSet(gbl+IntegerToString(OrderTicket())+".SL", sl);
            }
        }
        if (sl != 0 && OrderType() == OP_SELL)
        {
          if (UseBreakEven && NormalizeDouble(OrderOpenPrice()-Ask-BreakEvenAtPips*point, _Digits)>=0)
            if (NormalizeDouble(sl, _Digits)>NormalizeDouble(OrderOpenPrice()-BreakEvenSlidePips*point, _Digits))
            {
              sl = NormalizeDouble(OrderOpenPrice()-BreakEvenSlidePips*point, _Digits);
              dummyResult = OrderModify(OrderTicket(), OrderOpenPrice(), sl, OrderTakeProfit(), 0);
              GlobalVariableSet(gbl+IntegerToString(OrderTicket())+".SL", sl);
            }
        }
      }
}
//+------------------------------------------------------------------+
void ManageSL()
{
  double sl;
  for (int i = OrdersTotal() - 1; i >= 0; i--)
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == Magic)
      {
        sl = GlobalVariableGet(gbl+IntegerToString(OrderTicket())+".SL");
        if (sl == 0 && OrderType() == OP_BUY)
        {
          if (UseStopLoss) sl = NormalizeDouble(OrderOpenPrice() - StopLossPips*point, _Digits);
          dummyResult = OrderModify(OrderTicket(), OrderOpenPrice(), sl, 0, 0);
          GlobalVariableSet(gbl+IntegerToString(OrderTicket())+".SL", sl);
        }
        if (sl == 0 && OrderType() == OP_SELL)
        {
          if (UseStopLoss) sl = NormalizeDouble(OrderOpenPrice() + StopLossPips*point, _Digits);
          dummyResult = OrderModify(OrderTicket(), OrderOpenPrice(), sl, 0, 0);
          GlobalVariableSet(gbl+IntegerToString(OrderTicket())+".SL", sl);
        }
      }
}
//+------------------------------------------------------------------+
int GetSignal(int &shift)
{
  shift = -1;
  for (int i = 1; i < Bars; i++)
  {    
    double x11 = iCustom(NULL, timeFrame, "SuperTrend volty like 2 - nmt","", period, appliedPrice, multiplier,note, alertsOn, alertsOnCurrent, alertsMessage, alertsSound, alertsEmail, soundfile, 0, i);
    double x21 = iCustom(NULL, timeFrame, "SuperTrend volty like 2 - nmt","", period, appliedPrice, multiplier,note, alertsOn, alertsOnCurrent, alertsMessage, alertsSound, alertsEmail, soundfile, 2, i);
    double x12 = iCustom(NULL, timeFrame, "SuperTrend volty like 2 - nmt","", period, appliedPrice, multiplier,note, alertsOn, alertsOnCurrent, alertsMessage, alertsSound, alertsEmail, soundfile, 0, i+1);
    double x22 = iCustom(NULL,  timeFrame,"SuperTrend volty like 2 - nmt","", period, appliedPrice, multiplier,note, alertsOn, alertsOnCurrent, alertsMessage, alertsSound, alertsEmail, soundfile, 2, i+1);    
    if (x11 == EMPTY_VALUE) x11 = 0; if (x12 == EMPTY_VALUE) x12 = 0;
    if (x21 == EMPTY_VALUE) x21 = 0; if (x22 == EMPTY_VALUE) x22 = 0;
    shift = i;
    if (x11 != 0 && x12 == 0) return (OP_BUY);
    if (x21 != 0 && x22 == 0) return (OP_SELL);
  }
  return (-1);
}
//+------------------------------------------------------------------+

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+(string)iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                              return(Period());
}
string stringUpperCase(string str) { StringToUpper(str); return(str); }